/**
 * SaveLoad module.
 * Handles saving and loading of the adventure.
 */

var SaveLoad = {
	filename: "savegame.json",
	
	/**
	 * Save the game state (hero + inventory + spells + world).
	 */
	save: function () {
		// Save the hero position too.
		hero.map = GetCurrentMap();
		hero.x = GetPersonX("Hero");
		hero.y = GetPersonY("Hero");
		hero.direction = GetPersonDirection("Hero");
		
		ScriptBind.saveState();
		
		var everything = {
			hero: hero,
			inventory: inventory,
			spells: spells,
			world: ScriptBind.world
		};
		
		var f = OpenRawFile("../save/" + SaveLoad.filename, true);
		f.write(CreateByteArrayFromString(everything.toJSONString()));
		f.close();
	},
	
	/**
	 * Load the game state.
	 */
	load: function () {
		var f = OpenRawFile("../save/" + SaveLoad.filename);
		var s = CreateStringFromByteArray(f.read(f.getSize()));
		f.close();
		
		var everything = s.parseJSON();
		hero = everything.hero;
		inventory = everything.inventory;
		spells = everything.spells;
		ScriptBind.world = everything.world;
	},
	
	/**
	 * Check if a save file exists.
	 */
	saveFileExists: function () {
		return Util.fileExists("save", SaveLoad.filename);
	}
};