/**
 * oh noes dragon!!1
 */

RequireScript("Battle.js");
RequireScript("ColorSwap.js");
RequireScript("flik_menu.js");
RequireScript("Items.js");
RequireScript("json.js");
RequireScript("Magic.js");
RequireScript("Person.js");
RequireScript("SaveLoad.js");
RequireScript("ScriptBind.js");
RequireScript("TextBox.js");
RequireScript("Utility.js");


var font = GetSystemFont();
var windowStyle = GetSystemWindowStyle();

/**
 * lololol global variables.
 * Just these + world state = whole game!
 */
var inventory = [
	"Potion",
	"Potion",
	"S. Potion"
];
var spells = [
	{name: "Earth", level: 0},
	{name: "Fire", level: 0},
	{name: "Wind", level: 0},
	{name: "Water", level: 0},
	{name: "Heart", level: 0}
];
var hero = {
	map: "", x: 0, y: 0, direction: "",
	level: 1, exp: 0, next: 20,
	hp: 1, hpMax: 20,
	mp: 10, mpMax: 10,
	str: 6, def: 6, mag: 5,
	weapon: "wut sword", weaponLevel: 1,
	armor: "wut armour", armorLevel: 1
};


/**
 * game function.
 * Everything starts here!
 */
function game() {
	ScriptBind.start();
	titleScreen();
}


/**
 * Show the title screen and menu.
 */
function titleScreen() {
	var titleMenu = new DefaultMenu(120, 180, 100, 100);
	titleMenu.mouseSupport = false;
	
	// Title screen drawer
	var titleImage = LoadImage("title.png");
	var titleMenuBlitter = titleMenu.preRender;
	titleMenu.preRender = function () {
		titleImage.blit(0, 0);
		titleMenuBlitter.apply(titleMenu);
	};
	
	// Continue
	titleMenu.addText("Continue", function () {
		loadGame();
		titleMenu.selection = 0;
	});
	
	// New game
	titleMenu.addText("New Game", function () {
		newGame();
		titleMenu.selection = 0;
	});
	
	// Quit
	titleMenu.addText("Quit", Exit);
	
	titleMenu.execute();
}

/**
 * Start a new game.
 * Reset any variables from the last game,
 * and prepare a new game.
 */
function newGame() {
	// Clear the old game.
	ScriptBind.world = {};
	inventory = ["Potion", "Ether"];
	Func.forEach(spells, function (s) {
		s.level = 1;
	});
	hero = {
		map: "", x: 0, y: 0, direction: "",
		level: 1, exp: 0, next: 20,
		hp: 20, hpMax: 20,
		mp: 10, mpMax: 10,
		str: 6, def: 6, mag: 5,
		weapon: "wut sword", weaponLevel: 1,
		armor: "wut armour", armorLevel: 1
	};
	
	TextBox.clearLocation();
	
	// Prepare the new game.
	Person.makeHero();
	Person.initialFace("Hero", "south");
	AttachInput("Hero");
	AttachCamera("Hero");
	
	BindKey(KEY_ESCAPE, "mainMenu();", "");
	
	MapEngine("SlobTown.rmp", 60);
	SetRenderScript('');
}

/**
 * Load a saved game and resume gameplay.
 */
function loadGame() {
	if (SaveLoad.saveFileExists()) {
		SaveLoad.load();
		
		Person.makeHero();
		AttachInput("Hero");
		AttachCamera("Hero");
		
		BindKey(KEY_ESCAPE, "mainMenu();", "");
		
		TextBox.clearLocation();
		
		var commands = [
			'SetPersonX("Hero", ' + hero.x + ')',
			'SetPersonY("Hero", ' + hero.y + ')',
			'SetPersonDirection("Hero", "' + hero.direction + '")'
		];
		Func.forEach(commands, function (c) {
			QueuePersonScript("Hero", c, false);
		});
		MapEngine(hero.map, 60);
		SetRenderScript('');
	} else {
		TextBox.say("No save file found.");
	}
}


/**
 * Main menu.
 */
function mainMenu() {
	var menu = new DefaultMapMenu(20, 20, 100, 200);
	menu.mouseSupport = false;
	
	// Main menu drawing.
	var menuPreRender = menu.preRender;
	menu.preRender = function () {
		menuPreRender();
		drawHeroStats();
	}
	
	// Items
	menu.addText("Items", Items.menu);
	
	// Magic
	menu.addText("Magic", Magic.menu);
	
	// Save
	menu.addText("Save", function () {
		SaveLoad.save();
		TextBox.say("Saved!");
		menu.done = true;
	});
	
	// Quit
	menu.addText("Quit", function () {
		ExitMapEngine();
		menu.done = true;
	});
	
	// Back
	menu.addText("Back", function () {
		menu.selection = 0;
		menu.done = true;
	});
	
	menu.execute();
}

/**
 * Draws the various stats of the "hero".
 */
function drawHeroStats() {
	var stats = [
		"Hero L" + hero.level,
		"Exp: " + hero.exp + " / " + hero.next,
		"",
		"HP: " + hero.hp + " / " + hero.hpMax,
		"MP: " + hero.mp + " / " + hero.mpMax,
		"",
		"Strength: " + hero.str,
		"Defense: " + hero.def,
		"Magic: " + hero.mag,
		"",
		"Weapon: " + hero.weapon,
		"Armour: " + hero.armor
	];
	
	var w = Math.max.apply(null, Func.map(font.getStringWidth, stats));
	var h = font.getHeight() * stats.length;
	var x = GetScreenWidth() - (w + font.getStringWidth(" ") * 2);
	var y = GetScreenHeight() - (h + font.getHeight() * 2);
	
	// Draw away.
	windowStyle.drawWindow(x, y, w, h);
	Func.forEachIndex(stats, function (line, stat) {
		font.drawText(x, y + line * font.getHeight(), stat);
		++line;
	});
}