/**
 * DragonTower.
 * Not really a tower, but at least it's got a... dragon.
 * And a... princess.
 * Some chests for extras too.
 */

/** MAP EVENTS */

function mapEnter() {
	TextBox.renderLocation("Dragon Tower?");
}

function mapLeaveNorth() {
	Person.warp("Hero", 7, 11, "World.rmp", "north");
}

/** PERSONS */

// Dragon
function Dragon() {
	var alive = true;
	
	function save() {
		return {
			alive: alive
		};
	}
	
	function load(state) {
		alive = state.alive;
	}
	
	function create() {
		if (!alive) {
			QueuePersonScript("Dragon", 'DestroyPerson("Dragon")', true);
		}
	}
	
	function talk() {
		TextBox.say("I am a mighty dragon. I have the princess.");
		TextBox.say("Wait... this princess is a man!");
		TextBox.say("Argh my heart-");
		alive = false;
		DestroyPerson("Dragon");
	}
	
	return {
		save: save,
		load: load,
		
		create: create,
		talk: talk
	};
}

// Princess
function Princess() {
	var alive = true;
	
	function save() {
		return {
			alive: alive
		};
	}
	
	function load(state) {
		alive = state.alive;
	}
	
	function create() {
		if (!alive) {
			QueuePersonScript("Princess", 'DestroyPerson("Princess")', true);
		} else {
			Person.initialFace("Princess", "south");
		}
	}
	
	function talk() {
		TextBox.say("No, princess, you are the mans.");
		TextBox.say("And then the princess was a man.");
		TextBox.say("Prepare to die!");
		enemy.hpMax = 200;
		enemy.mpMax = 50;
		Battle.begin(false);
		enemy.hpMax = 20;
		enemy.mpMax = 5;
		alive = false;
		DestroyPerson("Princess");
		TextBox.say("Now there is nothing left to do. Go grind or something.");
		TextBox.say("Thanks for playing! -- tunginobi");
	}
	
	return {
		save: save,
		load: load,
		
		create: create,
		talk: talk
	};
}

({
	mapEnter: mapEnter,
	mapLeaveNorth: mapLeaveNorth,
	
	Dragon: Dragon(),
	Princess: Princess()
});