/**
 * Forest.
 * Contains armour, a weapon and a nasty "goblin".
 */

/** MAP EVENTS */

function mapEnter() {
	TextBox.renderLocation("Forest");
}

function mapLeaveNorth() {
	Person.warp("Hero", 23, 15, "World.rmp", "north");
}

function mapLeaveSouth() {
	Person.warp("Hero", 16, 26, "World.rmp", "south");
}

/** PERSONS */

// Goblin
function Goblin() {
	var alive = true;
	
	function save() {
		return {
			alive: alive
		};
	}
	
	function load(state) {
		alive = state.alive;
	}
	
	function create() {
		if (alive) {
			Person.initialFace("Goblin", "alive");
		} else {
			QueuePersonScript("Goblin", 'DestroyPerson("Goblin"); ', true);
		}
	}
	
	function talk() {
		TextBox.say("I'm meant to be a goblin. Yarg.");
		Battle.begin(false);
		alive = false;
		DestroyPerson("Goblin");
	}
	
	return {
		save: save,
		load: load,
		
		create: create,
		talk: talk
	};
}

/**
 * Register handles.
 */
({
	mapEnter: mapEnter,
	mapLeaveNorth: mapLeaveNorth,
	mapLeaveSouth: mapLeaveSouth,
	
	chest_1: Person.makeChest("chest_1", "Shirt"),
	chest_2: Person.makeChest("chest_2", "Stick"),
	Goblin: Goblin()
});