/**
 * Mountains.
 * More items, and two "bosses", I guess.
 */

/** MAP EVENTS */

function mapEnter() {
	TextBox.renderLocation("Mountains");
}

function mapLeaveSouth() {
	Person.warp("Hero", 23, 9, "World.rmp", "south");
}

function mapLeaveWest() {
	Person.warp("Hero", 13, 5, "World.rmp", "west");
}

/** PERSONS */

// male_1
function male_1() {
	function create() {
		Person.colorAndFace("male_1", "west",
			128, 128, 255,
			192, 164, 128,
			32, 32, 255);
	}
	
	function talk() {
		TextBox.say("Who designed these maps?");
	}
	
	return {
		create: create,
		talk: talk
	};
}

// circle_1
function circle_1() {
	var alive = true;
	
	function save() {
		return {
			alive: alive
		};
	}
	
	function load(state) {
		alive = state.alive;
	}
	
	function create() {
		if (alive) {
			Person.initialFace("circle_1", "alive");
		} else {
			QueuePersonScript("circle_1", 'DestroyPerson("circle_1"); ', true);
		}
	}
	
	function talk() {
		TextBox.say("STOP. HAMMER TIME.");
		Battle.begin(false);
		alive = false;
		DestroyPerson("circle_1");
	}
	
	return {
		save: save,
		load: load,
		
		create: create,
		talk: talk
	};
}

({
	mapEnter: mapEnter,
	mapLeaveSouth: mapLeaveSouth,
	mapLeaveWest: mapLeaveWest,
	
	male_1: male_1(),
	circle_1: circle_1(),
	
	chest_1: Person.makeChest("chest_1", "Knife"),
	chest_2: Person.makeChest("chest_2", "Jacket"),
	chest_3: Person.makeChest("chest_3", "S. Potion"),
	chest_4: Person.makeChest("chest_4", "S. Ether"),
	chest_5: Person.makeChest("chest_5", "M. Potion"),
	chest_6: Person.makeChest("chest_6", "Elixir"),
	chest_7: Person.makeChest("chest_7", "Sword"),
	chest_8: Person.makeChest("chest_8", "Vest")
});