/**
 * World.
 * The poorly-designed overworld.
 */

/** MAP EVENTS */

function mapEnter() {
	TextBox.renderLocation("Overworld");
}

/** PERSONS */

// SlobTown
function SlobTown() {
	function create() {
		Person.initialFace("SlobTown", "town");
	}
	function talk() {
		Person.warp("Hero", 16, 30, "SlobTown.rmp", "north");
	}
	return {
		create: create,
		talk: talk
	};
}

// ForestSouth
function ForestSouth() {
	function create() {
		Person.initialFace("ForestSouth", "cave");
	}
	function talk() {
		Person.warp("Hero", 4, 30, "Forest.rmp", "north");
	}
	return {
		create: create,
		talk: talk
	};
}

// ForestNorth
function ForestNorth() {
	function create() {
		Person.initialFace("ForestNorth", "cave");
	}
	function talk() {
		Person.warp("Hero", 5, 1, "Forest.rmp", "south");
	}
	return {
		create: create,
		talk: talk
	};
}

// MountainsSouth
function MountainsSouth() {
	function create() {
		Person.initialFace("MountainsSouth", "cave");
	}
	function talk() {
		Person.warp("Hero", 17, 18, "Mountains.rmp", "north");
	}
	return {
		create: create,
		talk: talk
	};
}

// MountainsWest
function MountainsWest() {
	function create() {
		Person.initialFace("MountainsWest", "cave");
	}
	function talk() {
		Person.warp("Hero", 1, 2, "Mountains.rmp", "east");
	}
	return {
		create: create,
		talk: talk
	};
}

// DragonTower
function DragonTower() {
	function create() {
		Person.initialFace("DragonTower", "tower");
	}
	function talk() {
		Person.warp("Hero", 2, 1, "DragonTower.rmp", "south");
	}
	return {
		create: create,
		talk: talk
	};
}

/**
 * Register handles.
 */
({
	mapEnter: mapEnter,
	
	SlobTown: SlobTown(),
	ForestSouth: ForestSouth(),
	ForestNorth: ForestNorth(),
	MountainsSouth: MountainsSouth(),
	MountainsWest: MountainsWest(),
	DragonTower: DragonTower()
});